# typed: true
# frozen_string_literal: true

module ApplicationHelper

  # Returns the full title on a per-page basis.
  def full_title(page_title)
    base_title = 'AQ'
    if page_title.empty?
      base_title
    else
      "#{base_title} | #{page_title}"
    end
  end

  def htmlstring(x)
    raw('"' + x.to_s + '"')
  end

  def pluralize_without_count(count, noun, text = nil)
    return if count == 0

    count == 1 ? "#{noun}#{text}" : "#{noun.pluralize}#{text}"
  end

end
